<template>
  <v-form>
    <v-container fluid>
      <v-row>
        <v-col cols="12" sm="6" md="6">
          <v-text-field
            v-model="item.street"
            :error-messages="streetErrors"
            :label="$t('street')"
            @input="$v.item.street.$touch()"
            @blur="$v.item.street.$touch()"
          />
        </v-col>
      
        <v-col cols="12" sm="6" md="6">
          <v-text-field
            v-model="item.city"
            :error-messages="cityErrors"
            :label="$t('city')"
            @input="$v.item.city.$touch()"
            @blur="$v.item.city.$touch()"
          />
        </v-col>
      </v-row>
      
      <v-row>
        <v-col cols="12" sm="6" md="6">
          <v-text-field
            v-model="item.country"
            :error-messages="countryErrors"
            :label="$t('country')"
            @input="$v.item.country.$touch()"
            @blur="$v.item.country.$touch()"
          />
        </v-col>
      
        <v-col cols="12" sm="6" md="6">
          <v-text-field
            v-model="item.zc"
            :error-messages="zcErrors"
            :label="$t('zc')"
            @input="$v.item.zc.$touch()"
            @blur="$v.item.zc.$touch()"
          />
        </v-col>
      </v-row>
      
    </v-container>
  </v-form>
</template>

<script>
import has from 'lodash/has';
import { validationMixin } from 'vuelidate';
//import { required } from 'vuelidate/lib/validators';
// import { mapActions } from 'vuex';
// import { mapFields } from 'vuex-map-fields';

export default {
  name: 'StoreForm',
  mixins: [validationMixin],
  props: {
    values: {
      type: Object,
      required: true
    },

    errors: {
      type: Object,
      default: () => {}
    },

    initialValues: {
      type: Object,
      default: () => {}
    }
  },
  mounted() {
  },
  data() {
    return {
        street: null,
        city: null,
        country: null,
        zc: null,
    };
  },
  computed: {

    // eslint-disable-next-line
    item() {
      return this.initialValues || this.values;
    },

    streetErrors() {
      const errors = [];

      if (!this.$v.item.street.$dirty) return errors;

      has(this.violations, 'street') && errors.push(this.violations.street);


      return errors;
    },
    cityErrors() {
      const errors = [];

      if (!this.$v.item.city.$dirty) return errors;

      has(this.violations, 'city') && errors.push(this.violations.city);


      return errors;
    },
    countryErrors() {
      const errors = [];

      if (!this.$v.item.country.$dirty) return errors;

      has(this.violations, 'country') && errors.push(this.violations.country);


      return errors;
    },
    zcErrors() {
      const errors = [];

      if (!this.$v.item.zc.$dirty) return errors;

      has(this.violations, 'zc') && errors.push(this.violations.zc);


      return errors;
    },

    violations() {
      return this.errors || {};
    }
  },
  methods: {
  },
  validations: {
    item: {
      street: {
      },
      city: {
      },
      country: {
      },
      zc: {
      },
    }
  }
};
</script>
